Sync to HEAD
[bpt/emacs.git] / lib-src / rcs2log
CommitLineData
daecaf5d
GM
1#! /bin/sh
2
3# RCS to ChangeLog generator
4
5# Generate a change log prefix from RCS files (perhaps in the CVS repository)
6# and the ChangeLog (if any).
7# Output the new prefix to standard output.
8# You can edit this prefix by hand, and then prepend it to ChangeLog.
9
10# Ignore log entries that start with `#'.
11# Clump together log entries that start with `{topic} ',
12# where `topic' contains neither white space nor `}'.
13
14Help='The default FILEs are the files registered under the working directory.
15Options:
16
17 -c CHANGELOG Output a change log prefix to CHANGELOG (default ChangeLog).
18 -h HOSTNAME Use HOSTNAME in change log entries (default current host).
19 -i INDENT Indent change log lines by INDENT spaces (default 8).
20 -l LENGTH Try to limit log lines to LENGTH characters (default 79).
1bd57c39 21 -L FILE Use rlog-format FILE for source of logs.
daecaf5d
GM
22 -R If no FILEs are given and RCS is used, recurse through working directory.
23 -r OPTION Pass OPTION to subsidiary log command.
24 -t TABWIDTH Tab stops are every TABWIDTH characters (default 8).
25 -u "LOGIN<tab>FULLNAME<tab>MAILADDR" Assume LOGIN has FULLNAME and MAILADDR.
26 -v Append RCS revision to file names in log lines.
27 --help Output help.
28 --version Output version number.
29
30Report bugs to <bug-gnu-emacs@gnu.org>.'
31
6b61353c 32Id='$Id: rcs2log,v 1.52 2003/12/27 08:18:08 uid65632 Exp $'
daecaf5d 33
6b61353c
KH
34# Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 2001, 2002, 2003,
35# 2004 Free Software Foundation, Inc.
daecaf5d
GM
36
37# This program is free software; you can redistribute it and/or modify
38# it under the terms of the GNU General Public License as published by
39# the Free Software Foundation; either version 2, or (at your option)
40# any later version.
41#
42# This program is distributed in the hope that it will be useful,
43# but WITHOUT ANY WARRANTY; without even the implied warranty of
44# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
45# GNU General Public License for more details.
46#
47# You should have received a copy of the GNU General Public License
48# along with this program; see the file COPYING. If not, write to the
49# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
50# Boston, MA 02111-1307, USA.
51
6b61353c 52Copyright='Copyright (C) 2004 Free Software Foundation, Inc.
daecaf5d
GM
53This program comes with NO WARRANTY, to the extent permitted by law.
54You may redistribute copies of this program
55under the terms of the GNU General Public License.
56For more information about these matters, see the files named COPYING.
57Author: Paul Eggert <eggert@twinsun.com>'
58
1bd57c39
PE
59# Use the traditional C locale.
60LANG=C
61LANGUAGE=C
62LC_ALL=C
63LC_COLLATE=C
64LC_CTYPE=C
65LC_MESSAGES=C
66LC_NUMERIC=C
67LC_TIME=C
68export LANG LANGUAGE LC_ALL LC_COLLATE LC_CTYPE LC_MESSAGES LC_NUMERIC LC_TIME
69
70# These variables each contain a single ASCII character.
71# Unfortunately, there's no portable way of writing these characters
72# in older Unix implementations, other than putting them directly into
73# this text file.
74SOH='\ 1' # SOH, octal code 001
daecaf5d
GM
75tab=' '
76nl='
77'
78
79# Parse options.
80
81# defaults
b2ba2352
PE
82AWK=${AWK-awk}
83TMPDIR=${TMPDIR-/tmp}
daecaf5d
GM
84changelog=ChangeLog # change log file name
85datearg= # rlog date option
86hostname= # name of local host (if empty, will deduce it later)
87indent=8 # indent of log line
88length=79 # suggested max width of log line
89logins= # login names for people we know fullnames and mailaddrs of
90loginFullnameMailaddrs= # login<tab>fullname<tab>mailaddr triplets
91logTZ= # time zone for log dates (if empty, use local time)
92recursive= # t if we want recursive rlog
93revision= # t if we want revision numbers
94rlog_options= # options to pass to rlog
1bd57c39 95rlogfile= # log file to read from
daecaf5d
GM
96tabwidth=8 # width of horizontal tab
97
98while :
99do
100 case $1 in
101 -c) changelog=${2?}; shift;;
102 -i) indent=${2?}; shift;;
103 -h) hostname=${2?}; shift;;
104 -l) length=${2?}; shift;;
1bd57c39 105 -L) rlogfile=${2?}; shift;;
daecaf5d
GM
106 -[nu]) # -n is obsolescent; it is replaced by -u.
107 case $1 in
108 -n) case ${2?}${3?}${4?} in
109 *"$tab"* | *"$nl"*)
110 echo >&2 "$0: -n '$2' '$3' '$4': tabs, newlines not allowed"
1bd57c39 111 exit 1;;
daecaf5d 112 esac
1bd57c39
PE
113 login=$2
114 lfm=$2$tab$3$tab$4
daecaf5d
GM
115 shift; shift; shift;;
116 -u)
117 # If $2 is not tab-separated, use colon for separator.
118 case ${2?} in
119 *"$nl"*)
120 echo >&2 "$0: -u '$2': newlines not allowed"
121 exit 1;;
122 *"$tab"*)
123 t=$tab;;
124 *)
1bd57c39 125 t=':';;
daecaf5d
GM
126 esac
127 case $2 in
128 *"$t"*"$t"*"$t"*)
129 echo >&2 "$0: -u '$2': too many fields"
130 exit 1;;
131 *"$t"*"$t"*)
1bd57c39
PE
132 uf="[^$t]*$t" # An unselected field, followed by a separator.
133 sf="\\([^$t]*\\)" # The selected field.
134 login=`expr "X$2" : "X$sf"`
135 lfm="$login$tab"`
136 expr "X$2" : "$uf$sf"
137 `"$tab"`
138 expr "X$2" : "$uf$uf$sf"
139 `;;
daecaf5d
GM
140 *)
141 echo >&2 "$0: -u '$2': not enough fields"
1bd57c39 142 exit 1;;
daecaf5d 143 esac
1bd57c39 144 shift;;
daecaf5d
GM
145 esac
146 case $logins in
147 '') logins=$login;;
1bd57c39 148 ?*) logins=$logins$nl$login;;
daecaf5d 149 esac
1bd57c39
PE
150 case $loginFullnameMailaddrs in
151 '') loginFullnameMailaddrs=$lfm;;
152 ?*) loginFullnameMailaddrs=$loginFullnameMailaddrs$nl$lfm;;
153 esac;;
daecaf5d
GM
154 -r)
155 case $rlog_options in
156 '') rlog_options=${2?};;
1bd57c39 157 ?*) rlog_options=$rlog_options$nl${2?};;
daecaf5d
GM
158 esac
159 shift;;
160 -R) recursive=t;;
161 -t) tabwidth=${2?}; shift;;
162 -v) revision=t;;
163 --version)
164 set $Id
165 rcs2logVersion=$3
166 echo >&2 "rcs2log (GNU Emacs) $rcs2logVersion$nl$Copyright"
167 exit 0;;
168 -*) echo >&2 "Usage: $0 [OPTION]... [FILE ...]$nl$Help"
169 case $1 in
170 --help) exit 0;;
1bd57c39 171 *) exit 1;;
daecaf5d 172 esac;;
1bd57c39 173 *) break;;
daecaf5d
GM
174 esac
175 shift
176done
177
178month_data='
179 m[0]="Jan"; m[1]="Feb"; m[2]="Mar"
180 m[3]="Apr"; m[4]="May"; m[5]="Jun"
181 m[6]="Jul"; m[7]="Aug"; m[8]="Sep"
182 m[9]="Oct"; m[10]="Nov"; m[11]="Dec"
183'
184
1bd57c39
PE
185logdir=$TMPDIR/rcs2log$$
186llogout=$logdir/l
187trap exit 1 2 13 15
188trap "rm -fr $logdir 2>/dev/null" 0
189(umask 077 && exec mkdir $logdir) || exit
daecaf5d 190
1bd57c39
PE
191# If no rlog-format log file is given, generate one into $rlogfile.
192case $rlogfile in
daecaf5d 193'')
1bd57c39
PE
194 rlogfile=$logdir/r
195
196 # If no rlog options are given,
197 # log the revisions checked in since the first ChangeLog entry.
6b61353c
KH
198 # Since ChangeLog is only by date, some of these revisions may be
199 # duplicates of what's already in ChangeLog; it's the user's
200 # responsibility to remove them.
1bd57c39
PE
201 case $rlog_options in
202 '')
203 if test -s "$changelog"
204 then
205 e='
206 /^[0-9]+-[0-9][0-9]-[0-9][0-9]/{
207 # ISO 8601 date
208 print $1
209 exit
210 }
211 /^... ... [ 0-9][0-9] [ 0-9][0-9]:[0-9][0-9]:[0-9][0-9] [0-9]+ /{
212 # old-fashioned date and time (Emacs 19.31 and earlier)
213 '"$month_data"'
214 year = $5
215 for (i=0; i<=11; i++) if (m[i] == $2) break
216 dd = $3
217 printf "%d-%02d-%02d\n", year, i+1, dd
218 exit
219 }
220 '
221 d=`$AWK "$e" <"$changelog"` || exit
222 case $d in
223 ?*) datearg="-d>$d";;
224 esac
225 fi;;
226 esac
227
228 # Use TZ specified by ChangeLog local variable, if any.
daecaf5d
GM
229 if test -s "$changelog"
230 then
1bd57c39
PE
231 extractTZ='
232 /^.*change-log-time-zone-rule['"$tab"' ]*:['"$tab"' ]*"\([^"]*\)".*/{
233 s//\1/; p; q
daecaf5d 234 }
1bd57c39
PE
235 /^.*change-log-time-zone-rule['"$tab"' ]*:['"$tab"' ]*t.*/{
236 s//UTC0/; p; q
daecaf5d
GM
237 }
238 '
1bd57c39
PE
239 logTZ=`tail "$changelog" | sed -n "$extractTZ"`
240 case $logTZ in
241 ?*) TZ=$logTZ; export TZ;;
daecaf5d
GM
242 esac
243 fi
daecaf5d 244
1bd57c39
PE
245 # If CVS is in use, examine its repository, not the normal RCS files.
246 if test ! -f CVS/Repository
247 then
248 rlog=rlog
249 repository=
250 else
251 rlog='cvs -q log'
252 repository=`sed 1q <CVS/Repository` || exit
253 test ! -f CVS/Root || CVSROOT=`cat <CVS/Root` || exit
6b61353c 254 pository=
1bd57c39 255 case $CVSROOT in
6b61353c
KH
256 /* | :fork:* | :local:*) ;;
257 */*)
1bd57c39 258 # remote repository
6b61353c
KH
259 pository=`expr "X$CVSROOT" : '[^/]*\(.*\)'`;;
260 esac
261 case $pository in
262 '')
1bd57c39
PE
263 # local repository
264 case $repository in
265 /*) ;;
6b61353c
KH
266 *)
267 repository=${CVSROOT?}/$repository
268 case $repository in
269 :fork:* | :local:*)
270 repository=`expr "$repository" : ':[^:]*:\(.*\)'`;;
271 esac;;
1bd57c39
PE
272 esac
273 if test ! -d "$repository"
274 then
275 echo >&2 "$0: $repository: bad repository (see CVS/Repository)"
276 exit 1
277 fi
278 pository=$repository;;
daecaf5d 279 esac
daecaf5d 280
1bd57c39
PE
281 # Ensure that $pository ends in exactly one slash.
282 while :
283 do
284 case $pository in
285 *//) pository=`expr "X$pository" : 'X\(.*\)/'`;;
286 */) break;;
287 *) pository=$pository/; break;;
288 esac
289 done
290
6b61353c
KH
291 # If no rlog options are given, and if we are in a tagged CVS branch,
292 # log only the changes in that branch.
293 case $rlog_options in
294 '')
295 if test -f CVS/Tag
296 then
297 CVSTAG=`cat <CVS/Tag` || exit
298 case $CVSTAG in
299 T?*)
300 rlog_options=-r`expr "$CVSTAG" : 'T\(.*\)'`;;
301 *)
302 echo >&2 "$0: invalid CVS/Tag"; exit 1;;
303 esac
304 fi;;
305 esac
1bd57c39
PE
306 fi
307
308 # Use $rlog's -zLT option, if $rlog supports it.
309 case `$rlog -zLT 2>&1` in
310 *' option'*) ;;
311 *)
312 case $rlog_options in
313 '') rlog_options=-zLT;;
314 ?*) rlog_options=-zLT$nl$rlog_options;;
315 esac;;
daecaf5d 316 esac
daecaf5d 317
1bd57c39
PE
318 # With no arguments, examine all files under the RCS directory.
319 case $# in
320 0)
321 case $repository in
322 '')
323 oldIFS=$IFS
324 IFS=$nl
325 case $recursive in
326 t)
327 RCSdirs=`find . -name RCS -type d -print`
328 filesFromRCSfiles='s|,v$||; s|/RCS/|/|; s|^\./||'
329 files=`
330 {
331 case $RCSdirs in
332 ?*) find $RCSdirs \
333 -type f \
334 ! -name '*_' \
335 ! -name ',*,' \
336 ! -name '.*_' \
337 ! -name .rcsfreeze.log \
338 ! -name .rcsfreeze.ver \
339 -print;;
340 esac
341 find . -name '*,v' -print
342 } |
343 sort -u |
344 sed "$filesFromRCSfiles"
345 `;;
346 *)
347 files=
348 for file in RCS/.* RCS/* .*,v *,v
349 do
350 case $file in
351 RCS/. | RCS/.. | RCS/,*, | RCS/*_) continue;;
352 RCS/.rcsfreeze.log | RCS/.rcsfreeze.ver) continue;;
353 RCS/.\* | RCS/\* | .\*,v | \*,v) test -f "$file" || continue;;
354 RCS/*,v | RCS/.*,v) ;;
355 RCS/* | RCS/.*) test -f "$file" || continue;;
daecaf5d 356 esac
1bd57c39
PE
357 case $files in
358 '') files=$file;;
359 ?*) files=$files$nl$file;;
360 esac
361 done
daecaf5d 362 case $files in
1bd57c39
PE
363 '') exit 0;;
364 esac;;
daecaf5d 365 esac
1bd57c39
PE
366 set x $files
367 shift
368 IFS=$oldIFS;;
369 esac;;
daecaf5d 370 esac
daecaf5d 371
1bd57c39
PE
372 case $datearg in
373 ?*) $rlog $rlog_options "$datearg" ${1+"$@"} >$rlogfile;;
374 '') $rlog $rlog_options ${1+"$@"} >$rlogfile;;
375 esac || exit;;
376esac
daecaf5d
GM
377
378
b2ba2352
PE
379# Prefer the POSIX-style -k options, since POSIX 1003.1-2001 prohibits
380# support for the traditional-style +M -N options.
381SORT_K_OPTIONS='-k 3,4r -k 5 -k 1'
382sort $SORT_K_OPTIONS </dev/null 2>/dev/null || SORT_K_OPTIONS='+2 -4r +4 +0'
383
384
daecaf5d
GM
385# Get the full name of each author the logs mention, and set initialize_fullname
386# to awk code that initializes the `fullname' awk associative array.
387# Warning: foreign authors (i.e. not known in the passwd file) are mishandled;
388# you have to fix the resulting output by hand.
389
390initialize_fullname=
391initialize_mailaddr=
392
393case $loginFullnameMailaddrs in
394?*)
395 case $loginFullnameMailaddrs in
396 *\"* | *\\*)
397 sed 's/["\\]/\\&/g' >$llogout <<EOF || exit
398$loginFullnameMailaddrs
399EOF
1bd57c39 400 loginFullnameMailaddrs=`cat $llogout`;;
daecaf5d
GM
401 esac
402
403 oldIFS=$IFS
404 IFS=$nl
405 for loginFullnameMailaddr in $loginFullnameMailaddrs
406 do
1bd57c39 407 IFS=$tab
daecaf5d
GM
408 set x $loginFullnameMailaddr
409 login=$2
410 fullname=$3
411 mailaddr=$4
412 initialize_fullname="$initialize_fullname
413 fullname[\"$login\"] = \"$fullname\""
414 initialize_mailaddr="$initialize_mailaddr
415 mailaddr[\"$login\"] = \"$mailaddr\""
416 done
1bd57c39 417 IFS=$oldIFS;;
daecaf5d
GM
418esac
419
1bd57c39
PE
420case $logins in
421?*)
422 sort -u -o $llogout <<EOF
daecaf5d
GM
423$logins
424EOF
1bd57c39
PE
425 ;;
426'')
427 : ;;
428esac >$llogout || exit
429
daecaf5d
GM
430output_authors='/^date: / {
431 if ($2 ~ /^[0-9]*[-\/][0-9][0-9][-\/][0-9][0-9]$/ && $3 ~ /^[0-9][0-9]:[0-9][0-9]:[0-9][0-9][-+0-9:]*;$/ && $4 == "author:" && $5 ~ /^[^;]*;$/) {
432 print substr($5, 1, length($5)-1)
433 }
434}'
435authors=`
1bd57c39 436 $AWK "$output_authors" <"$rlogfile" | sort -u | comm -23 - $llogout
daecaf5d
GM
437`
438case $authors in
439?*)
440 cat >$llogout <<EOF || exit
441$authors
442EOF
443 initialize_author_script='s/["\\]/\\&/g; s/.*/author[\"&\"] = 1/'
444 initialize_author=`sed -e "$initialize_author_script" <$llogout`
445 awkscript='
446 BEGIN {
447 alphabet = "abcdefghijklmnopqrstuvwxyz"
448 ALPHABET = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
449 '"$initialize_author"'
450 }
451 {
452 if (author[$1]) {
453 fullname = $5
454 if (fullname ~ /[0-9]+-[^(]*\([0-9]+\)$/) {
455 # Remove the junk from fullnames like "0000-Admin(0000)".
456 fullname = substr(fullname, index(fullname, "-") + 1)
457 fullname = substr(fullname, 1, index(fullname, "(") - 1)
458 }
459 if (fullname ~ /,[^ ]/) {
460 # Some sites put comma-separated junk after the fullname.
461 # Remove it, but leave "Bill Gates, Jr" alone.
462 fullname = substr(fullname, 1, index(fullname, ",") - 1)
463 }
464 abbr = index(fullname, "&")
465 if (abbr) {
466 a = substr($1, 1, 1)
467 A = a
468 i = index(alphabet, a)
469 if (i) A = substr(ALPHABET, i, 1)
470 fullname = substr(fullname, 1, abbr-1) A substr($1, 2) substr(fullname, abbr+1)
471 }
472
473 # Quote quotes and backslashes properly in full names.
474 # Do not use gsub; traditional awk lacks it.
475 quoted = ""
476 rest = fullname
477 for (;;) {
478 p = index(rest, "\\")
479 q = index(rest, "\"")
480 if (p) {
481 if (q && q<p) p = q
482 } else {
483 if (!q) break
484 p = q
485 }
486 quoted = quoted substr(rest, 1, p-1) "\\" substr(rest, p, 1)
487 rest = substr(rest, p+1)
488 }
489
490 printf "fullname[\"%s\"] = \"%s%s\"\n", $1, quoted, rest
491 author[$1] = 0
492 }
493 }
494 '
495
496 initialize_fullname=`
497 {
498 (getent passwd $authors) ||
499 (
500 cat /etc/passwd
501 for author in $authors
502 do NIS_PATH= nismatch $author passwd.org_dir
503 done
504 ypmatch $authors passwd
505 )
506 } 2>/dev/null |
507 $AWK -F: "$awkscript"
1bd57c39 508 `$initialize_fullname;;
daecaf5d
GM
509esac
510
511
512# Function to print a single log line.
513# We don't use awk functions, to stay compatible with old awk versions.
1bd57c39 514# `Log' is the log message.
daecaf5d
GM
515# `files' contains the affected files.
516printlogline='{
517
518 # Following the GNU coding standards, rewrite
519 # * file: (function): comment
520 # to
521 # * file (function): comment
e8d6a09b 522 if (Log ~ /^\([^)]*\):[\t\n ]/) {
daecaf5d 523 i = index(Log, ")")
1bd57c39
PE
524 filefunc = substr(Log, 1, i)
525 while ((j = index(filefunc, "\n"))) {
526 files = files " " substr(filefunc, 1, j-1)
527 filefunc = substr(filefunc, j+1)
528 }
529 files = files " " filefunc
daecaf5d
GM
530 Log = substr(Log, i+3)
531 }
532
533 # If "label: comment" is too long, break the line after the ":".
534 sep = " "
1bd57c39
PE
535 i = index(Log, "\n")
536 if ('"$length"' <= '"$indent"' + 1 + length(files) + i) sep = "\n" indent_string
daecaf5d
GM
537
538 # Print the label.
539 printf "%s*%s:", indent_string, files
540
1bd57c39
PE
541 # Print each line of the log.
542 while (i) {
daecaf5d
GM
543 logline = substr(Log, 1, i-1)
544 if (logline ~ /[^'"$tab"' ]/) {
545 printf "%s%s\n", sep, logline
546 } else {
547 print ""
548 }
549 sep = indent_string
550 Log = substr(Log, i+1)
1bd57c39 551 i = index(Log, "\n")
daecaf5d
GM
552 }
553}'
554
555# Pattern to match the `revision' line of rlog output.
556rlog_revision_pattern='^revision [0-9]+\.[0-9]+(\.[0-9]+\.[0-9]+)*(['"$tab"' ]+locked by: [^'"$tab"' $,.0-9:;@]*[^'"$tab"' $,:;@][^'"$tab"' $,.0-9:;@]*;)?['"$tab"' ]*$'
557
558case $hostname in
559'')
560 hostname=`(
561 hostname || uname -n || uuname -l || cat /etc/whoami
562 ) 2>/dev/null` || {
563 echo >&2 "$0: cannot deduce hostname"
564 exit 1
565 }
566
567 case $hostname in
568 *.*) ;;
569 *)
570 domainname=`(domainname) 2>/dev/null` &&
571 case $domainname in
1bd57c39
PE
572 *.*) hostname=$hostname.$domainname;;
573 esac;;
574 esac;;
daecaf5d
GM
575esac
576
577
578# Process the rlog output, generating ChangeLog style entries.
579
580# First, reformat the rlog output so that each line contains one log entry.
1bd57c39 581# Transliterate \n to SOH so that multiline entries fit on a single line.
daecaf5d 582# Discard irrelevant rlog output.
1bd57c39
PE
583$AWK '
584 BEGIN {
585 pository = "'"$pository"'"
586 SOH="'"$SOH"'"
587 }
588 /^RCS file: / {
589 if (pository != "") {
590 filename = substr($0, 11)
591 if (substr(filename, 1, length(pository)) == pository) {
592 filename = substr(filename, length(pository) + 1)
daecaf5d
GM
593 }
594 if (filename ~ /,v$/) {
595 filename = substr(filename, 1, length(filename) - 2)
596 }
597 if (filename ~ /(^|\/)Attic\/[^\/]*$/) {
598 i = length(filename)
599 while (substr(filename, i, 1) != "/") i--
600 filename = substr(filename, 1, i - 6) substr(filename, i + 1)
601 }
602 }
603 rev = "?"
604 }
1bd57c39 605 /^Working file: / { if (repository == "") filename = substr($0, 15) }
daecaf5d
GM
606 /'"$rlog_revision_pattern"'/, /^(-----------*|===========*)$/ {
607 line = $0
608 if (line ~ /'"$rlog_revision_pattern"'/) {
609 rev = $2
610 next
611 }
612 if (line ~ /^date: [0-9][- +\/0-9:]*;/) {
613 date = $2
614 if (date ~ /\//) {
615 # This is a traditional RCS format date YYYY/MM/DD.
616 # Replace "/"s with "-"s to get ISO format.
617 newdate = ""
618 while ((i = index(date, "/")) != 0) {
619 newdate = newdate substr(date, 1, i-1) "-"
620 date = substr(date, i+1)
621 }
622 date = newdate date
623 }
624 time = substr($3, 1, length($3) - 1)
625 author = substr($5, 1, length($5)-1)
1bd57c39 626 printf "%s%s%s%s%s%s%s%s%s%s", filename, SOH, rev, SOH, date, SOH, time, SOH, author, SOH
daecaf5d
GM
627 rev = "?"
628 next
629 }
630 if (line ~ /^branches: /) { next }
631 if (line ~ /^(-----------*|===========*)$/) { print ""; next }
632 if (line == "Initial revision" || line ~ /^file .+ was initially added on branch .+\.$/) {
633 line = "New file."
634 }
1bd57c39 635 printf "%s%s", line, SOH
daecaf5d 636 }
1bd57c39 637' <"$rlogfile" |
daecaf5d
GM
638
639# Now each line is of the form
1bd57c39
PE
640# FILENAME@REVISION@YYYY-MM-DD@HH:MM:SS[+-TIMEZONE]@AUTHOR@LOG
641# where @ stands for an SOH (octal code 001),
642# and each line of LOG is terminated by SOH instead of \n.
daecaf5d
GM
643# Sort the log entries, first by date+time (in reverse order),
644# then by author, then by log entry, and finally by file name and revision
645# (just in case).
b2ba2352 646sort -t"$SOH" $SORT_K_OPTIONS |
daecaf5d
GM
647
648# Finally, reformat the sorted log entries.
1bd57c39 649$AWK -F"$SOH" '
daecaf5d
GM
650 BEGIN {
651 logTZ = "'"$logTZ"'"
652 revision = "'"$revision"'"
653
daecaf5d
GM
654 # Initialize the fullname and mailaddr associative arrays.
655 '"$initialize_fullname"'
656 '"$initialize_mailaddr"'
657
658 # Initialize indent string.
659 indent_string = ""
660 i = '"$indent"'
661 if (0 < '"$tabwidth"')
662 for (; '"$tabwidth"' <= i; i -= '"$tabwidth"')
663 indent_string = indent_string "\t"
664 while (1 <= i--)
665 indent_string = indent_string " "
666 }
667
668 {
1bd57c39
PE
669 newlog = ""
670 for (i = 6; i < NF; i++) newlog = newlog $i "\n"
daecaf5d
GM
671
672 # Ignore log entries prefixed by "#".
673 if (newlog ~ /^#/) { next }
674
675 if (Log != newlog || date != $3 || author != $5) {
676
677 # The previous log and this log differ.
678
679 # Print the old log.
680 if (date != "") '"$printlogline"'
681
682 # Logs that begin with "{clumpname} " should be grouped together,
683 # and the clumpname should be removed.
684 # Extract the new clumpname from the log header,
685 # and use it to decide whether to output a blank line.
686 newclumpname = ""
687 sep = "\n"
688 if (date == "") sep = ""
689 if (newlog ~ /^\{[^'"$tab"' }]*}['"$tab"' ]/) {
690 i = index(newlog, "}")
691 newclumpname = substr(newlog, 1, i)
692 while (substr(newlog, i+1) ~ /^['"$tab"' ]/) i++
693 newlog = substr(newlog, i+1)
e8d6a09b 694 if (clumpname == newclumpname && date == $3 && author == $5) sep = ""
daecaf5d
GM
695 }
696 printf sep
697 clumpname = newclumpname
698
699 # Get ready for the next log.
700 Log = newlog
701 if (files != "")
702 for (i in filesknown)
703 filesknown[i] = 0
704 files = ""
705 }
706 if (date != $3 || author != $5) {
707 # The previous date+author and this date+author differ.
708 # Print the new one.
709 date = $3
710 time = $4
711 author = $5
712
713 zone = ""
714 if (logTZ && ((i = index(time, "-")) || (i = index(time, "+"))))
715 zone = " " substr(time, i)
716
717 # Print "date[ timezone] fullname <email address>".
718 # Get fullname and email address from associative arrays;
719 # default to author and author@hostname if not in arrays.
720 if (fullname[author])
721 auth = fullname[author]
722 else
723 auth = author
724 printf "%s%s %s ", date, zone, auth
725 if (mailaddr[author])
726 printf "<%s>\n\n", mailaddr[author]
727 else
728 printf "<%s@%s>\n\n", author, "'"$hostname"'"
729 }
730 if (! filesknown[$1]) {
731 filesknown[$1] = 1
732 if (files == "") files = " " $1
733 else files = files ", " $1
734 if (revision && $2 != "?") files = files " " $2
735 }
736 }
737 END {
738 # Print the last log.
739 if (date != "") {
740 '"$printlogline"'
741 printf "\n"
742 }
743 }
744' &&
745
746
747# Exit successfully.
748
749exec rm -fr $logdir
750
751# Local Variables:
752# tab-width:4
753# End:
6b61353c
KH
754
755# arch-tag: cea067bd-a552-4254-ba17-078208933073